#!/usr/bin/perl -w
use File::Find;
use MDK::Common;
use strict;
use locale;

-d $ARGV[0] || exit 0;

my @list;

find({wanted => sub { -d $_ && ! -l && push @list, $File::Find::name}},$ARGV[0]);

foreach my $directory (@list) {
  my %entries;

  foreach my $file (grep { !/^\./ } all($directory)) {
    my $real_file = "$directory/$file";
    next if (-l $real_file && -d $real_file);
    $real_file ="$real_file/.directory" if -d $real_file;

    $entries{$file} = $file;
    open (FILE, $real_file) or print("unable to open $real_file\n"), next;
    while (<FILE>) {
      chomp;
      my ($name, $value) = /(.*?)=(.*)/ or next;
      if ( $name eq "Name[$ENV{LANG}]" ) {
	$entries{$file} = eval { pack "c*", unpack "U*", $value } || $value;
	last;
      }
    }
    close (FILE);
  }
  open (ORDER, "> $directory/.order") or die "unable to open $directory/.order\n";
  foreach my $item ( sort { $entries{$a} cmp $entries{$b} } keys %entries) {
    print ORDER "$item\n";
  }
  close (ORDER);
}

